VERSION 5.00
Begin VB.Form frmClipping 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Bitmap API's [Clipping]"
   ClientHeight    =   4830
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5820
   Icon            =   "GDI Clipping.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   322
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   388
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picBanner 
      Align           =   1  'Align Top
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   615
      Left            =   0
      MouseIcon       =   "GDI Clipping.frx":08CA
      MousePointer    =   99  'Custom
      Picture         =   "GDI Clipping.frx":0D0C
      ScaleHeight     =   615
      ScaleWidth      =   5820
      TabIndex        =   6
      Top             =   0
      Width           =   5820
   End
   Begin VB.Frame fraActions 
      Caption         =   "Actions"
      Height          =   975
      Left            =   0
      TabIndex        =   3
      Top             =   3840
      Width           =   3615
      Begin VB.CommandButton cmdCls 
         Caption         =   "Clear"
         Height          =   375
         Left            =   1920
         TabIndex        =   5
         Top             =   360
         Width           =   1575
      End
      Begin VB.CommandButton cmdUnClip 
         Caption         =   "Unclip"
         Height          =   375
         Left            =   120
         TabIndex        =   4
         Top             =   360
         Width           =   1575
      End
   End
   Begin VB.Frame fraMode 
      Caption         =   "Mouse Action Mode"
      Height          =   975
      Left            =   3720
      TabIndex        =   0
      Top             =   3840
      Width           =   2055
      Begin VB.OptionButton optModeClipping 
         Caption         =   "Clipping Select"
         Height          =   255
         Left            =   120
         TabIndex        =   2
         Top             =   600
         Width           =   1695
      End
      Begin VB.OptionButton optModeDraw 
         Caption         =   "Drawing"
         Height          =   255
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Value           =   -1  'True
         Width           =   1695
      End
   End
End
Attribute VB_Name = "frmClipping"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'==================================================================
'
' GDI Clipping Window Sample
'
' 6 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


Private dcPaint As GDIDC
Private dcPaintEx As GDIDCEx
Private fcsSelector As DCFocusRect
Private MouseDrag As Boolean


'------------------------------------------------------------------
' Assign Some GDI Objects

Private Sub Form_Load()
  Set dcPaint = GDIAttachDC(Me.hDC, False)  ' Edit current dc
  Set dcPaintEx = GDIAttachDCEx(dcPaint)    ' Add more drawing features to it.
  Set fcsSelector = GDIFocusDC(Me.hDC)      ' Draw docus area on this dc.
End Sub

'------------------------------------------------------------------
' Clear Screen

Private Sub cmdCls_Click()
  Dim bshFill As GDIBrush
  Set bshFill = GDICreateBrush(Me.BackColor)
  Set dcPaint.SelBrush = bshFill
  Call dcPaintEx.Drawing.DrawRectEx(0, 0, dcPaint.SelBitmap.Width, dcPaint.SelBitmap.Height, True)
  Call dcPaint.RestoreBrush
  Set bshFill = Nothing
  If Me.AutoRedraw Then Call Me.Refresh
End Sub

'------------------------------------------------------------------
' Unclip that window

Private Sub cmdUnClip_Click()
  Call dcPaintEx.Clipping.SetRegion(Nothing) ' unclip
  optModeDraw.Value = True
End Sub


'------------------------------------------------------------------
' Draw or select?

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  ' initialize action
  If optModeClipping Then
    Call dcPaintEx.Clipping.SetRegion(Nothing) ' unclip
    fcsSelector.X1 = Me.ScaleX(X, Me.ScaleMode, fcsSelector.ScaleMode)
    fcsSelector.Y1 = Me.ScaleY(Y, Me.ScaleMode, fcsSelector.ScaleMode)
    fcsSelector.X2 = Me.ScaleX(X, Me.ScaleMode, fcsSelector.ScaleMode)
    fcsSelector.Y2 = Me.ScaleY(Y, Me.ScaleMode, fcsSelector.ScaleMode)
  ElseIf optModeDraw Then
    Call dcPaintEx.CurrentPos.Move(Me.ScaleX(X, Me.ScaleMode, vbPixels), Me.ScaleY(Y, Me.ScaleMode, vbPixels))
  End If
  MouseDrag = True
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  ' do action
  If MouseDrag Then
    If optModeClipping Then
      fcsSelector.X2 = Me.ScaleX(X, Me.ScaleMode, fcsSelector.ScaleMode)
      fcsSelector.Y2 = Me.ScaleY(Y, Me.ScaleMode, fcsSelector.ScaleMode)
      If Not fcsSelector.Visible Then fcsSelector.Visible = True
    ElseIf optModeDraw Then
      Call dcPaintEx.Drawing.DrawLineTo(Me.ScaleX(X, Me.ScaleMode, vbPixels), Me.ScaleY(Y, Me.ScaleMode, vbPixels))
    End If
    If Me.AutoRedraw Then Call Me.Refresh
  End If
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  ' terminate action
  If optModeClipping Then
    Dim rgnArea As New GDIRegion
    fcsSelector.X2 = Me.ScaleX(X, Me.ScaleMode, fcsSelector.ScaleMode)
    fcsSelector.Y2 = Me.ScaleY(Y, Me.ScaleMode, fcsSelector.ScaleMode)
    fcsSelector.Visible = False
    Call dcPaintEx.Drawing.DrawRect(fcsSelector.X1 - 1, fcsSelector.Y1 - 1, fcsSelector.X2 + 1, fcsSelector.Y2 + 1)
    Call rgnArea.CreateRect(fcsSelector.X1, fcsSelector.Y1, fcsSelector.X2, fcsSelector.Y2)
    Call dcPaintEx.Clipping.SetRegion(rgnArea)
    optModeDraw.Value = True
    If Me.AutoRedraw Then Call Me.Refresh
  End If
  MouseDrag = False
End Sub

Private Sub optModeClipping_Click()
  fcsSelector.Visible = False
End Sub



'------------------------------------------------------------------
' Banner

Private Sub picBanner_Click()
  MsgBox "Copyright  2001 - Diederik van der Boor" & vbCrLf _
       & vbCrLf _
       & "Anyone is allowed to use this software freely, as long as" & vbCrLf _
       & "the the copright information in the source code remains intact." & vbCrLf _
       & vbCrLf _
       & "http://www.codingdomain.com"
End Sub


